<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Mostviewed Import Entity by Amasty
 */

namespace Amasty\MostviewedImportEntity\Import\Validation;

use Amasty\Base\Model\Serializer;
use Amasty\ImportCore\Api\Validation\FieldValidatorInterface;

class JsonValidator implements FieldValidatorInterface
{
    /**
     * @var Serializer
     */
    private $serializer;

    public function __construct(
        Serializer $serializer
    ) {
        $this->serializer = $serializer;
    }

    public function validate(array $row, string $field): bool
    {
        if (isset($row[$field])) {
            try {
                return (bool)$this->serializer->unserialize($row[$field]);
            } catch (\Exception $e) {
                return false;
            }
        }

        return true;
    }
}
